enable_mask	equ	80h
escape_mask	equ	40h
count_mask	equ	20h
expect_mask	equ	10h
graphic_mask	equ	08h
download_mask	equ	04h
;?_mask 	equ	02h
skipzero_mask	equ	01h

code		segment byte public
		assume cs: code, ds: code

		org	100h

main		proc
		jmp	init
entr:
		cmp	ah,0feh 	; additional call to check
		jnz	short entr0	; whether installed
		mov	ax,0a55ah
		push	cs
		pop	es
		iret
entr0:
		push	bx
		push	dx
		push	ax
		push	ds
		push	cs
		pop	ds

		mov	symbol, al
		or	ah,ah
		jnz	short entr1a
		test	status, enable_mask
		je	short entr1a

		test	status, 07fh		; is any flag set?
		jne	short entr1
		cmp	symbol, 27		; is it escape?
		jne	short translate
		or	status, escape_mask
		jmp	original
translate:
		test	al, 80h
		je	short translate1
		mov	bx, offset table - 80h
		xlat	cs:[bx]
		mov	symbol, al
translate1:	jmp	original

entr1:
		test	status, escape_mask
		je	short entr2
		xor	status, escape_mask
		call	new_set
entr1a: 	jmp	original
entr2:
		test	status, expect_mask
		je	short entr3
		mov	al, expected
		cmp	symbol, al
		jne	short entr2a
		xor	status, expect_mask
entr2a: 	jmp	original
entr3:
		test	status, skipzero_mask
		je	short entr4
		xor	status, skipzero_mask
		cmp	symbol, 0
		jne	short entr4
		inc	counter
entr4:
		test	status, count_mask
		je	short entr5
		dec	counter
		jne	short entr5
		xor	status, count_mask
entr5:
		test	status, graphic_mask
		je	short entr6
		mov	bx, counter
		mov	queue[bx], al
		test	status, count_mask
		jne	short original
		xor	status, graphic_mask
		mov	bh, queue[0]		; gr bytes count
		mov	bl, queue[1]
		mov	counter, bx
		or	status, count_mask
		jmp	original
entr6:
		test	status, download_mask
		je	short entr7
		mov	bx, counter
		mov	queue[bx], al
		test	status, count_mask
		jne	short original
		xor	status, download_mask
		mov	al, queue[0]
		sub	al, queue[1]
		inc	al
		mov	bl, 12
		mul	bl
		mov	counter, ax
		or	status, count_mask
		jmp	original
entr7:
original:
		pop	ds
		pop	ax
		pop	dx
		pop	bx

		mov	al, cs:symbol
		jmp	cs:[old_17]


new_set:			; al contains symbol
		mov	bx, sym0 - sym
set1:		dec	bx
		js	short set2
		cmp	sym[bx], al
		jne	short set1
		mov	counter, 1
		or	status, count_mask
		ret
sym		db	'RpIW-SA3JrNalQby\U'
sym0:

set2:
		cmp	al, '%'
		jne	short set3
		mov	counter, 2
		or	status, count_mask
		ret
set3:
		cmp	al, ':'
		jne	short set4
		mov	counter, 3
		or	status, count_mask
		ret
set4:
		cmp	al, 'C'
		jne	short set5
		mov	counter, 1
		or	status, count_mask + skipzero_mask
		ret
set5:
		cmp	al, 'B'
		je	short set5a
		cmp	al, 'D'
		jne	short set6
set5a:		mov	expected, 0
		or	status, expect_mask
		ret
set6:
		cmp	al, '+'
		jne	short set7
		mov	expected, 30
		or	status, expect_mask
		ret
set7:
		cmp	al, 'K'
		je	short set7a
		cmp	al, 'L'
		je	short set7a
		cmp	al, 'Y'
		je	short set7a
		cmp	al, 'Z'
		jne	short set8
set7a:		mov	counter, 2
		or	status, count_mask + graphic_mask
		ret
set8:
		cmp	al, '*'
		jne	short set9
		mov	counter, 3
		or	status, count_mask + graphic_mask
		ret
set9:
		cmp	al, '&'
		jne	short set0
		mov	counter, 3
		or	status, count_mask + download_mask
set0:
		ret

table:		db	'ABEKMHOPCTX'
		db	'aeopcx'
		db	'Źο'
		db	''

old_17		dd	?
status		db	enable_mask
symbol		db	0
expected	db	0
counter 	dw	0
queue		db	0,0,0,0,0

;-----------------------------------------------------------------------

init:		nop
		push	cs
		pop	ds

		mov	dx, offset copyright
		mov	ax, 900h
		int	21h

		mov	ah,0feh 	; check whether installed
		int	17h
		cmp	ax,0a55ah
		jne	short install
		xor	es:status,enable_mask	; toggle enable flag
		and	es:status,enable_mask	; clear other flags
		jnz	short on
		mov	dx, offset disabled
		jmp	pr
on:		mov	dx, offset enabled
pr:		mov	ax, 900h
		int	21h
		ret

install:
		mov	status,enable_mask

		xor	ax, ax
		mov	es, ax
		cli
		mov	ax, es:[17h*4]
		mov	word ptr old_17, ax
		mov	ax, es:[17h*4 + 2]
		mov	word ptr old_17 + 2, ax
		push	ds
		push	es
		pop	ds
		mov	ds:word ptr [4*17h], offset entr
		mov	ds:word ptr [4*17h + 2], cs
		pop	ds
		sti

		mov	dx, offset init
		int	27h
exit:		ret

copyright	db	'Cyrillic Translation Driver for Star Gemini 10/15 Printers',13,10
		db	'Version 1.00     (c) 1989 Eagle software & YGP, Unico SRDL',13,10
		db	'$'
enabled 	db	'SG-15 printer driver enabled',13,10,'$'
disabled	db	'SG-15 printer driver disabled',13,10,'$'

main		endp
code		ends
		end	main
